/***************************************************************************
 *   Copyright 2008 by Davide Bettio <davide.bettio@kdemail.net>           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#ifndef KEYBOARDLEDS_H
#define KEYBOARDLEDS_H

#include <Plasma/Applet>
#include <Plasma/Svg>

class KDialog;

class KeyboardLeds : public Plasma::Applet
{
    Q_OBJECT
    public:
        KeyboardLeds(QObject *parent, const QVariantList &args);
        ~KeyboardLeds();

        void init();
        Qt::Orientations expandingDirections() const;
        QSizeF contentSizeHint() const;
        void constraintsEvent(Plasma::Constraints constraints);
        void paintInterface(QPainter *painter, const QStyleOptionGraphicsItem *option, const QRect& contentsRect);

    protected slots:
        void configAccepted();

    private slots:
        void updateLedsStatus();

    private:
        Plasma::Svg *m_svg;
        bool m_sizedirty;

        unsigned int getKeyMask(unsigned int key);

        unsigned int numLockMask;
        unsigned int capsLockMask;
        unsigned int scrollLockMask;

        unsigned int numLock;
        unsigned int capsLock;
        unsigned int scrollLock;
};

K_EXPORT_PLASMA_APPLET(keyboardLeds, KeyboardLeds)

#endif
